/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "widgetoptions.h"
#include "calcul.h"

#include <QtGui>

WidgetOptions::WidgetOptions(QWidget* parent) : QDialog( parent) {
	//titre de la fentre
	setWindowTitle(QString("Choix des canonisations"));
	
	//boutons  cocher pour les diverses canonisations
	QLabel *titrecano1 = new QLabel(this);
	titrecano1->setText("Activer \"2+2=2x2\" :");
	titrecano1->setFont( font_monospace );
	cano1 = new QCheckBox(this);
	connect( cano1, SIGNAL(toggled (bool)), this, SLOT(modif_cano1(bool)) );
	
	QLabel *titrecano2 = new QLabel(this);
	titrecano2->setText("Activer \"sous-calcul\" :");
	titrecano2->setFont( font_monospace );
	cano2 = new QCheckBox(this);
	connect( cano2, SIGNAL(toggled (bool)), this, SLOT(modif_cano2(bool)) );
	
	QLabel *titrecano3 = new QLabel(this);
	titrecano3->setText("Activer \"factorisation\" :");
	titrecano3->setFont( font_monospace );
	cano3 = new QCheckBox(this);
	connect( cano3, SIGNAL(toggled (bool)), this, SLOT(modif_cano3(bool)) );
	
	//bouton pour rtablir les options par dfaut
	pbDefaut = new QPushButton( "Options par dfaut", this );
	pbDefaut->setFont( font_normal );
	connect( pbDefaut, SIGNAL( clicked() ), this, SLOT( modif_cano_defaut() ) );
	
	//bouton "OK" pour fermer la fentre
	pbOk = new QPushButton( "OK", this );
	pbOk->setFont( font_normal );
	connect( pbOk, SIGNAL( clicked() ), this, SLOT( close() ) );
	
	//potisionnement des widgets
	layout = new QGridLayout;
	setMaximumHeight( 150 );
	setMaximumWidth( 300 );
	layout->addWidget(titrecano1, 0, 0);
	layout->addWidget(cano1, 0, 1);
	layout->addWidget(titrecano2, 1, 0);
	layout->addWidget(cano2, 1, 1);
	layout->addWidget(titrecano3, 2, 0);
	layout->addWidget(cano3, 2, 1);
	layout->addWidget(pbDefaut, 3, 0);
	layout->addWidget(pbOk, 3, 1);
	
	setLayout(layout);
	
	//initialisation des etats
	if (calcul::cano1_actif==true) {
		cano1->setCheckState(Qt::Checked);
	} else {
		cano1->setCheckState(Qt::Unchecked);
	}
	
	if (calcul::cano2_actif==true) {
		cano2->setCheckState(Qt::Checked);
	} else {
		cano2->setCheckState(Qt::Unchecked);
	}
	
	if (calcul::cano3_actif==true) {
		cano3->setCheckState(Qt::Checked);
	} else {
		cano3->setCheckState(Qt::Unchecked);
	}
}

void WidgetOptions::modif_cano1(bool val) {
	calcul::cano1_actif=val;
}

void WidgetOptions::modif_cano2(bool val) {
	calcul::cano2_actif=val;
}

void WidgetOptions::modif_cano3(bool val) {
	calcul::cano3_actif=val;
}

//Pour remettre les options  leur valeur par dfaut
void WidgetOptions::modif_cano_defaut() {
	calcul::cano1_actif=true;
	calcul::cano2_actif=true;
	calcul::cano3_actif=true;
	cano1->setCheckState(Qt::Checked);
	cano2->setCheckState(Qt::Checked);
	cano3->setCheckState(Qt::Checked);
}
